// (C) Copyright 1998 D.C.Meintjes - dirk@kivtronics.co.za
//---------------------------------------------------------------------------
#ifndef ModemH
#define ModemH

#include "uart.h"
#include "ModemProgress.h"
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#define TAPI_CURRENT_VERSION	0x00010004
#include <tapi.h>
//---------------------------------------------------------------------------
// this structure holds the modem info returned by TAPI
typedef struct modem_info_tag
{
	VARSTRING vs;
	HANDLE hComm;
	char szDeviceName[255];
} MODEM_INFO, FAR *LPMODEM_INFO;
//---------------------------------------------------------------------------
// enumerated types
enum TDCModemStatus	{msIdle, msRinging, msAnswering, msConnecting, msConnected,
					 msWaitReply, msDialling, msBusy, msDisconnected};
//---------------------------------------------------------------------------
// Custom events
typedef void __fastcall (__closure *TStatusChangeEvent)(TObject *Sender, TDCModemStatus Status, String StatStr);
typedef void __fastcall (__closure *TConnectEvent)(TObject *Sender, TDCModemStatus Status);
typedef void __fastcall (__closure *TDisconnectEvent)(TObject *Sender, TDCModemStatus Status);
typedef void __fastcall (__closure *TDeviceChangeEvent)(TObject *Sender, DWORD NewDevice);

//*****************************************************************************
// classdeclaration form TModem component
//
class TModem : public TComponent
{
private:
// these variables are used internally and are not property storage holders
	HLINEAPP LineApp;							// handle to TAPI DLL connection
	HLINE Line;									// handle to TAPI line
	HCALL Call;									// handle to TAPI call
	LINECALLPARAMS CallParams;					// parameters of call
	HANDLE hCommDevice;							// communications file handle
	bool Connected;								// holds state of modem connection
	bool DialogOpen;
	DWORD DeviceCount;							// number of modems installed
	DWORD tapiVersion;							// version of TAPI we'll use
	DWORD DeviceID;								// ID of selected modem
	DWORD DeviceIndex;							// index of current device
	TUart *FUart;

	void __fastcall BuildDeviceList();			// builds list of attached modems

// property storage variables
	TDCModemStatus	FStatus;					// holds our line status

// event handler storage
	TStatusChangeEvent	FStatusChangeEvent;	// called when status changes
	TConnectEvent		FConnectEvent;		// called when modem connects
	TDisconnectEvent	FDisconnectEvent;	// called when call is disconnected
	TDeviceChangeEvent	FDeviceChangeEvent;	// called when user select new

protected:

public:
	bool ProgressDlgOpen;
	TStringList *ModemList;
	DWORD RingsToAnswer;
	TModemProgressDlg *ProgressDlg;
	String TelNo;

	__fastcall TModem(TComponent* Owner);
	__fastcall ~TModem();
	void __fastcall Shutdown();
	void __fastcall Startup();
	void __fastcall SetStatus(TDCModemStatus stat, String s);
// property getters/setters
	HANDLE __fastcall GetHandle(void);
	void __fastcall SetDevice(DWORD dev);

// methods callable by users
	bool __fastcall Dial(String No, bool UseDlg = false);
	void __fastcall Hangup();
	bool __fastcall Listen(DWORD Rings = 3);
	bool __fastcall UserConfigure(HWND h = NULL);
	void __fastcall UserSelectModem();

// runtime properties
	__property TDCModemStatus Status={read=FStatus};
	__property HANDLE Handle={read=GetHandle};
	__property DWORD Device={read=DeviceIndex,write=SetDevice};

__published:

// designtime properties
	__property TUart* Uart={read=FUart,write=FUart,default=NULL};

// events
	__property TStatusChangeEvent OnStatusChange={read=FStatusChangeEvent,write=FStatusChangeEvent};
	__property TConnectEvent OnConnect={read=FConnectEvent,write=FConnectEvent};
	__property TDisconnectEvent OnDisconnect={read=FDisconnectEvent,write=FDisconnectEvent};
	__property TDeviceChangeEvent OnDeviceChange={read=FDeviceChangeEvent,write=FDeviceChangeEvent};
};
extern TModem *ptrModem;

//*****************************************************************************
// TAPI callback function
//
void CALLBACK LineCallback(	DWORD hDevice, DWORD dwMsg, DWORD dwCallbackInstance,
							DWORD dwParam1, DWORD dwParam2, DWORD dwParam3);

#endif
